/***************************************************************************
                          FILENAME  -  description                              
                             -------------------                                         
    begin                : DATE                                           
    copyright            : (C) 2000 by Eric Coquelle <coquelle@caramail.com>
    email                : EMAIL                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include "cnavigateur.h"

#include <kdebug.h>
#include <qdragobject.h>

CArchiveBrowser::CArchiveBrowser(QWidget *parent, const char *name) : QDialog(parent,name,false){
  initDialog();

  //Additionnal init
  KIconLoader icone;
  mousebuttonpressed=false;
  setIcon(icone.loadIcon("karchiver.png",KIcon::Small));

  lPath->setFrameStyle( QFrame::Panel | QFrame::Sunken );
  QListBox_1->installEventFilter(this);
  setCaption(i18n("Archive Browser"));
}

CArchiveBrowser::~CArchiveBrowser(){
}

/** Set the current path for the browser */
void CArchiveBrowser::setPath(QString path)
{
  QStringList listefichiers;
  QDir d;

  lPath->setText(path);
  d.setPath(path);

  QListBox_1->clear();
  listefichiers=d.entryList("*gz");
  QListBox_1->insertStringList(listefichiers);
  listefichiers=d.entryList("*bz2");
  QListBox_1->insertStringList(listefichiers);
  listefichiers=d.entryList("*tar");
  QListBox_1->insertStringList(listefichiers);
  listefichiers=d.entryList("*.Z");
  QListBox_1->insertStringList(listefichiers);
  listefichiers=d.entryList("*zip");
  QListBox_1->insertStringList(listefichiers);
  listefichiers=d.entryList("*rar");
  QListBox_1->insertStringList(listefichiers);
  listefichiers=d.entryList("*lha");
  QListBox_1->insertStringList(listefichiers);
  listefichiers=d.entryList("*lzh");
  QListBox_1->insertStringList(listefichiers);
  listefichiers=d.entryList("*arj");
  QListBox_1->insertStringList(listefichiers);
}

QString CArchiveBrowser::getChemin()
{
  return lPath->text()+"/";
}

/** The user closed the window */
void CArchiveBrowser::closeEvent( QCloseEvent* ){
	emit(windowwillbeclosed());
}

bool CArchiveBrowser::eventFilter ( QObject * watched, QEvent * e )
{
        if(watched == QListBox_1)
        {
                        if(e->type()==QEvent:: MouseButtonPress)
                {
                        if(((QMouseEvent*)e)->button()==LeftButton)
                                mousebuttonpressed=true;
                        //return true;
                }
                else if(e->type()==QEvent:: MouseMove)
                {
                        if((mousebuttonpressed)&&((((QMouseEvent*)e)->x()<0)||(((QMouseEvent*)e)->x()>width())||(((QMouseEvent*)e)->y()<0)||(((QMouseEvent*)e)->y()>height())))
                        {
                                QStrList list;
                                list.append(getChemin()+QListBox_1->currentText());
                                kdDebug()<<QString("ArchiveBrowser Drag leaving: %1").arg(getChemin()+QListBox_1->currentText())<<endl;
                                QDragObject *d = new QUriDrag( list, this);
                                d->drag();
                                mousebuttonpressed=false;
                                return true;
                        }
                        else if(mousebuttonpressed)
                          return true;
                }
                else if(e->type()==QEvent:: MouseButtonRelease)
                {
                        mousebuttonpressed=false;
                        //return true;
                }
        }
        return QDialog::eventFilter(watched,e);
}

#include "cnavigateur.moc"
